/*
 * keypad.c
 *
 *  Created on: 2013-3-19
 *      Author: think
 */

#include "msp430x54xA.h"
#include "keysmg.h"


uchar	key_Pressed;
uchar	key_val;
uchar	key_flag;

uchar	key_Map[] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};


void Init_Keypad(void)
{
	KEY_DIR = 0X0f;
	KEY_DOUT |= 0X0f;
	key_flag = 0;
	key_Pressed = 0;
	key_val = 0;
}

void Check_Key(void)
{
	uchar row, col, tmp1, tmp2;

	tmp1 = 0x08;
	for(row=0; row<4; row++)
	{
		KEY_DOUT = 0X0f;
		KEY_DOUT -=tmp1;
		tmp1 >>=1;
		if((KEY_DIN&0xf0)<0xf0)
		{
			tmp2 = 0X10;
			for(col=0; col<4; col++)
			{
				if(0x00 == (KEY_DIN&tmp2))
				{
					key_val = key_Map[row*4 + col];
					return;
				}
				tmp2 <<= 1;
			}
		}
	}
}

void delay()
{
	uint tmp;
	for(tmp = 200000; tmp>0; tmp--);
}

void Key_Event(void)
{
	uchar tmp;
	KEY_DOUT =0x00;
	tmp = KEY_DIN;
	if ((0x00 == key_Pressed) && ((tmp & 0xf0) < 0xf0))
	{
		key_Pressed = 1;
		delay();
		Check_Key();
		key_flag    = 1;
	}
    else if ((key_Pressed == 1)&&((tmp & 0xf0) == 0xf0))
    {
        key_Pressed = 0;
        key_flag    = 1;
    }
    else
    {
        _NOP();
    }
}















