/*
 * keysmg.h
 *
 *  Created on: 2013-3-8
 *      Author: think
 */

#ifndef KEYSMG_H_
#define KEYSMG_H_

typedef unsigned char uchar;
typedef unsigned int uint;


/* board led1 and led2*/
#define LED1_ON		P5DIR |=BIT0;	P5OUT &=~BIT0		//Turn on LED1
#define LED1_OFF	P5DIR |=BIT0;	P5OUT |=BIT0		//Turn off LED1
#define LED1_F		P5DIR |=BIT0;	P5OUT ^=BIT0
#define LED2_ON		P5DIR |=BIT1;	P5OUT &=~BIT1		//Turn on LED2
#define LED2_OFF	P5DIR |=BIT1;	P5OUT |=BIT1		//Turn off LED2
#define LED2_F		P5DIR |=BIT1;	P5OUT ^=BIT1

/* BUZZER */
#define BUZZER_ON	P9DIR |=BIT6;	P9OUT|=BIT6;	P9DS|=BIT6
#define BUZZER_OFF	P9DIR |=BIT6;	P9OUT&=~BIT6

#define KEY1		P2DIR &= ~BIT4
#define	KEY2		P2DIR &= ~BIT5
#define	KEY3		P2DIR &= ~BIT6
#define	KEY4		P2DIR &= ~BIT7

/* KEYSMG */
#define LED_DATA_CTL		P8DIR = 0XFF				//ѡλ
#define LED_DATA			P8OUT
#define LED_SELECT_CTL1		P3DIR |= BIT0+BIT4+BIT5
#define LED_SELECT_CTL2		P11DIR|= BIT0+BIT1+BIT2
#define LED_SELECT_CTL3		P1DIR |= BIT6+BIT7

#define LED_SELECT_DATA1	P3OUT  &= ~BIT0;	P3OUT |=(BIT4+BIT5);	P11OUT |=(BIT0+BIT1+BIT2); P1OUT |=(BIT6+BIT7)
#define LED_SELECT_DATA2	P3OUT  &= ~BIT5;	P3OUT |=(BIT4+BIT0);	P11OUT |=(BIT0+BIT1+BIT2); P1OUT |=(BIT6+BIT7)
#define LED_SELECT_DATA3	P3OUT  &= ~BIT4;	P3OUT |=(BIT0+BIT5);	P11OUT |=(BIT0+BIT1+BIT2); P1OUT |=(BIT6+BIT7)
#define LED_SELECT_DATA4	P11OUT &= ~BIT0;	P3OUT |=(BIT0+BIT4+BIT5);	P11OUT |=(BIT1+BIT2);  P1OUT |=(BIT6+BIT7)
#define LED_SELECT_DATA5	P11OUT &= ~BIT1;	P3OUT |=(BIT0+BIT4+BIT5);	P11OUT |=(BIT0+BIT2);  P1OUT |=(BIT6+BIT7)
#define LED_SELECT_DATA6	P11OUT &= ~BIT2;	P3OUT |=(BIT0+BIT4+BIT5);	P11OUT |=(BIT0+BIT1);  P1OUT |=(BIT6+BIT7)
#define LED_SELECT_DATA7	P1OUT  &= ~BIT6;	P3OUT |=(BIT0+BIT4+BIT5);	P11OUT |=(BIT0+BIT1+BIT2);P1OUT |=BIT7
#define LED_SELECT_DATA8	P1OUT  &= ~BIT7;	P3OUT |=(BIT0+BIT4+BIT5);	P11OUT |=(BIT0+BIT1+BIT2);P1OUT |=BIT6
#define LED_SELECT_ALL		P3OUT &= ~(BIT0+BIT4+BIT5);P11OUT &= ~(BIT0+BIT1+BIT2); P1OUT &= ~(BIT6+BIT7)


/* 4X4 */
#define	KEY_DIR		P4DIR
#define KEY_DOUT	P4OUT
#define KEY_DIN		P4IN



#endif /* KEYSMG_H_ */
