/*
 * main.c
 */

#include "msp430x54xA.h"
#include "keysmg.h"
#include "keypad.h"
#include "gdata.h"

uchar    LED_SELECT_CNT;


void main(void) {
	WDTCTL = WDT_ADLY_1_9;
	SFRIE1 |= WDTIE;
	LED_DATA_CTL;
	LED_SELECT_CTL1;
	LED_SELECT_CTL2;
	LED_SELECT_CTL3;
	LED_DATA=0x00;
	Init_Keypad();
	_EINT();
    while(1)
    {
    	if(0xe0==(P2IN&0xF0))
    	{
    		LED_SELECT_ALL;
    		LED_DATA=0x80;
    	}

    	if(0xD0==(P2IN&0xF0))
    	{
    		LED_SELECT_DATA2;
    		LED_DATA=0XA4;
    	}
    	if(0xB0==(P2IN&0xF0))
    	{
    		LED_SELECT_DATA3;
    		LED_DATA=0XB0;
    	}
    	if(0x70==(P2IN&0xF0))
    	{
    		LED_SELECT_DATA4;
    		LED_DATA=0X99;
    	}

      Key_Event();
      if(key_flag == 1)
        {
          key_flag = 0;
          LED_MAP[0] = key_val / 10;
          LED_MAP[1] = key_val % 10;
        }
    }
}



#pragma vector = WDT_VECTOR
__interrupt void watchdog_timer(void)
{
  if(LED_SELECT_CNT<1)
  {
    LED_SELECT_CNT++;
  }
  else
  {
    LED_SELECT_CNT=0;
  }
  LED1_F;
  switch(LED_SELECT_CNT)
  {
  	case 0:
  	     LED_SELECT_DATA5;
  	     break;
  	case 1:
  	     LED_SELECT_DATA6;
  	     break;
  	default:
  	     break;
  }
  LED_DATA=scandata[LED_MAP[LED_SELECT_CNT]];
}
